<%@ PAGE LANGUAGE="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.IO" %>
<html>
<head>
<script runat="server">
void Page_Load(object sender, EventArgs e) {
	if (!IsPostBack) {
		datalist1.DataSource = CreateDataSource();
		datalist1.DataBind();
	}
}

ICollection CreateDataSource() {
	DirectoryInfo di = new DirectoryInfo(Server.MapPath("."));
	FileInfo[] fi = di.GetFiles();

	DataTable dt = new DataTable();
	DataRow dr;

	dt.Columns.Add(new DataColumn("fileid", typeof(int)));
	dt.Columns.Add(new DataColumn("filename", typeof(String)));
	dt.Columns.Add(new DataColumn("filesize", typeof(long)));
	dt.Columns.Add(new DataColumn("date", typeof(DateTime)));

	for (int i = 0; i < fi.Length; i++) {
		dr = dt.NewRow();
		dr[0] = i;
		dr[1] = fi[i].Name;
		dr[2] = fi[i].Length;
		dr[3] = fi[i].LastWriteTime;
		dt.Rows.Add(dr);
	}

	DataView dv = new DataView(dt);

	return dv;
}

void datalist1_Edit(object sender, DataListCommandEventArgs e) {
	datalist1.EditItemIndex = e.Item.ItemIndex;
	datalist1.DataSource = CreateDataSource();
	datalist1.DataBind();
}

void datalist1_Update(object sender, DataListCommandEventArgs e) {
	int fileid = (int) datalist1.DataKeys[e.Item.ItemIndex];
	TextBox textbox = (TextBox) e.Item.FindControl("filename");

	Message.Text = fileid.ToString() + " : " + textbox.Text;

	datalist1.EditItemIndex = -1;
	datalist1.DataSource = CreateDataSource();
	datalist1.DataBind();
}

void datalist1_Cancel(object sender, DataListCommandEventArgs e) {
	datalist1.EditItemIndex = -1;
	datalist1.DataSource = CreateDataSource();
	datalist1.DataBind();
}

void datalist1_Choice(object sender, DataListCommandEventArgs e) {
	if (e.CommandName == "choice") {
		datalist1.SelectedIndex = e.Item.ItemIndex;
		datalist1.DataSource = CreateDataSource();
		datalist1.DataBind();
	}
}

</script>
</head>
<body>
<form runat="server">
	<div align="center">
	<asp:DataList id="datalist1"
		CellPadding="4"
		DataKeyField="fileid"
		GridLines="Both"
		RepeatColumns="2"
		OnEditCommand="datalist1_Edit"
		OnUpdateCommand="datalist1_Update"
		OnCancelCommand="datalist1_Cancel"
		OnItemCommand="datalist1_Choice"
		runat="server">
		<HeaderTemplate>
			<p align="center"><%# Server.MapPath(".") %></p>
		</HeaderTemplate>
		<ItemTemplate>
			<%# DataBinder.Eval(Container.DataItem, "filename") %>
			( <%# DataBinder.Eval(Container.DataItem, "filesize") %> Bytes )
			<asp:LinkButton Text="ҏW" CommandName="edit" runat="server" />
			<asp:LinkButton Text="I" CommandName="choice" runat="server" />
		</ItemTemplate>
		<EditItemTemplate>
			<asp:TextBox id="filename" Text='<%# DataBinder.Eval(Container.DataItem, "filename") %>' runat="server" />
			<asp:LinkButton Text="XV" CommandName="update" runat="server" />
			<asp:LinkButton Text="LZ" CommandName="cancel" runat="server" />
		</EditItemTemplate>
		<SelectedItemTemplate>
			<b>
			<%# DataBinder.Eval(Container.DataItem, "filename") %>
			( <%# DataBinder.Eval(Container.DataItem, "date") %> )
			</b>
			<asp:LinkButton Text="ҏW" CommandName="edit" runat="server" />
			<asp:LinkButton Text="I" CommandName="choice" runat="server" />
		</SelectedItemTemplate>
		<FooterTemplate>
			<p align="right">
			<%# (new DirectoryInfo(Server.MapPath("."))).GetFiles().Length %>̃t@C܂
			</p>
		</FooterTemplate>
	</asp:DataList>
	<asp:Label id="Message" runat="server" />
	</div>
</form>
</body>
</html>
